<template>
  <tbody>
    <template v-if="activeData.length > 0">
      <tr
        v-for="(row, rowIndex) in activeData"
        :key="`project-${row.id}`"

      >
        <td
          v-for="(column, columnIndex) in columns"
          :key="`cell-${columnIndex}${rowIndex}`"
        >
          {{ getCell(column, row) }}
        </td>
        <td class="grid-body__actions">
          <router-link :to="{name: `${gridName}-edit`, params: {id: row.id}}">
            <i class="far fa-edit"></i>
          </router-link>
        </td>
      </tr>
    </template>
    <tr v-else>
      <td :colspan="columns.length + 1">
        <EmptySlot />
      </td>
    </tr>
  </tbody>
</template>
<script lang="ts">
import _ from 'lodash';
import Vue from 'vue';
import { Component, Inject } from 'vue-property-decorator';
import GridConfig, { Column, GridRow } from '@/components/grid/GridConfig';
import { namespace } from 'vuex-class';
import EmptySlot from './EmptySlot.vue';

const grid = namespace('grid');

@Component({
  components: {
    EmptySlot,
  },
})
export default class TableBody extends Vue {
  @Inject('gridColumns') private columns!: Array<Column>

  @Inject('gridConfig') private gridConfig!: GridConfig

  @grid.Getter
  public activeData!: Array<GridRow>

  get gridName(): string {
    return this.gridConfig.name;
  }

  getCell(column: Column, row: GridRow): string {
    const formatType = _.get(column, 'formatType', null);
    const cellValue = _.get(row, [column.key]);

    if (formatType === 'date') {
      const date = new Date(cellValue);

      const year = date.getUTCFullYear();
      const month = date.getUTCMonth() + 1;
      const day = date.getUTCDate();

      return `${day}.${month}.${year}`;
    }

    if (formatType === 'array') {
      return _.join(cellValue, ', ');
    }

    return _.get(row, [column.key]);
  }
}
</script>
